<?php
header('Connection: Keep-Alive');
header('Keep-Alive: timeout=60');
error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_DEPRECATED);
$rootPath = is_file("../../../../library/document.php") ? "../../../../" : "../../";
define("CMS", "korCMS");
session_id($_REQUEST['session']);
session_start();
require_once($rootPath . "functions.php");
$protocol = getProtocol();
$isAdminLoged = ($_SESSION['adminLevel'] == -1 || $_SESSION['adminLevel'] == 0); // master or client admin
if (!$isAdminLoged) die("Access Denied! Please log in as administrator");
include($rootPath . "config/odyssey.ini.php");
include($rootPath . "library/db.php");
include($rootPath . "library/system.php");
include($rootPath . "library/messages.php");
include($rootPath . "library/variables.php");
include($rootPath . "library/language.php");
include($rootPath . "library/parameters.php");
include($rootPath . "library/content.php");
include($rootPath . "library/document.php");
include($rootPath . "library/fileSystem.php");
include($rootPath . "library/imageResize.php");
include($rootPath . "library/iconResize.php");
include($rootPath . "library/dates.php");
include($rootPath . "library/categories.php");
include($rootPath . "library/authentication.php");
include($rootPath . "library/sef.php");
$db = new db();
$system = new system();
$messages = new messages();
$variables = new variables();
$language = new language();
$parameters = new parameters();
$content = new content();
$fileSystem = new fileSystem();
$imageResize = new imageResize();
$iconResize = new iconResize();
$dates = new dates();
$categories = new categories();
$auth = new authentication(true);
$db->query("SET NAMES 'utf8'");

$zip_filename = $rootPath . "admin/uploads/import.zip";
$sectionID = $system->getTableSectionID('articles');
$pages_sectionID = $system->getTableSectionID('pages');
$imported_text = "imported file "; // do not change!!!!
$loading_file = "loading.txt";
reset_loading();
$delimiter = ',';
$enclosure = '"';
$messages->importSessionMessages();
$settings = $_SESSION['moduleParameters'];
$maxChars = $settings['maxChars'];
$removeExisting = $settings['removeExisting'];
$imageSize = $settings['imageSize'];
$imageSize = $settings['imageSize'];
$category_section = "articles_categories";
$importLangID = $language->getDefaultLanguage(true);
$langExt = $language->getLanguageExtension($importLangID);
$langID = getAdminLanguage();
if (!$langID) $langID = ($_GET['langID']) ? (int)$_GET['langID'] : $language->getDefaultLanguage();
$Lsufix = ((int)$langID > 1) ? "_translated" : NULL;
$variables->getSafeVars(array_keys($_REQUEST));

function manage_loading($task, $total, $counter) {
    global $loading_file;
    $data = file($loading_file);
    list($loaded,) = explode("|", $data[0]);
    $loaded = (int)$loaded;
    $percent = (int)(100 * ($counter / $total));
    if ($percent > $loaded) {
        $fp = fopen($loading_file, "w");
        fwrite($fp, $percent . '|' . $task);
        fclose($fp);
    }
}

function reset_loading() {
    global $loading_file;
    $fp = fopen($loading_file, "w");
    fwrite($fp, '');
    fclose($fp);
}

function removeContent($section = 'articles') {
    global $rootPath, $system, $db, $content, $categories;
    if (is_numeric($section)) $section = $system->getTableSectionName($section);
    $sectionID = $system->getTableSectionID($section);
    if (!$sectionID) return false;
    // delete mediabank
    $bankIDs = $exceptionIDs = array();
    $q = "select bankID from `images` where sectionID = '$sectionID' 
            UNION 
            select bankID from `files` where sectionID = '$sectionID' ";
    $items = $db->getRecords($q);
    foreach ($items as $item) {
        // remove attachments
        $bankID = $item->bankID;
        $bankIDs[] = $bankID;
        $db->query("DELETE FROM content_images, images USING content_images INNER JOIN images
                            WHERE content_images.imgID=images.id AND images.bankID='$bankID' and images.sectionID='$sectionID'");
        $db->query("DELETE FROM content_files, files USING content_files INNER JOIN files
                            WHERE content_files.fileID=files.id AND files.bankID='$bankID' and files.sectionID='$sectionID'");
    }
    // get exceptions to prevent from removal of any other section images
    $q = "select bankID from `images` where sectionID <> '$sectionID' 
            UNION 
            select bankID from `files` where sectionID <> '$sectionID' ";
    $exceptions = $db->getRecords($q);
    foreach ($exceptions as $exception) $exceptionIDs[] = $exception->bankID;
    $delID = array_diff($bankIDs, $exceptionIDs); // get mediabank ids without the exceptions
    $content->massMediaBankDelete($delID);
    // delete articles
    $delID = array();
    $items = $db->getRecords("select id from `" . $section . "`");
    foreach ($items as $item) $delID[] = $item->id;
    $content->massContentDelete($delID, $section);
    // delete article categories
    $cat_section = $section . "_categories";
    $isCategorySection = $db->isTableExists($cat_section);
    if ($isCategorySection) {
        $isPreorderTreeTraversal = $categories->isPreorderTreeTraversal($cat_section);
        $items = $db->getRecords("select id from `" . $cat_section . "` where id > 1"); // preserve base category
        foreach ($items as $item) {
            $itemID = $item->id;
            if ($isPreorderTreeTraversal) {
                $db->query("LOCK TABLE $cat_section WRITE");
                $db->query("SELECT @myLeft := L, @myRight := R, @myWidth := R - L + 1 FROM $cat_section WHERE id = '$itemID'");
                $db->query("DELETE FROM $cat_section WHERE L BETWEEN @myLeft AND @myRight");
                $db->query("UPDATE $cat_section SET R = R - @myWidth WHERE R > @myRight");
                $db->query("UPDATE $cat_section SET L = L - @myWidth WHERE L > @myRight");
                $db->query("UNLOCK TABLES");
            } else {
                $db->query("delete from `$cat_section` where id='$itemID' ");
            }
            $content_table = "content_" . $cat_section;
            $db->query("delete from $content_table where catID='$itemID'");
            $db->query("DELETE FROM content_aliases, aliases USING content_aliases INNER JOIN aliases	
							   WHERE content_aliases.mainID=aliases.id 
							   AND aliases.itemID='$itemID' 
							   AND aliases.sectionID='$sectionID' 
							   AND aliases.isCategory=1");
            // delete any image category for this entry
            $categoryImage = $rootPath . "mediabank/" . $categories->getCategoryImage($itemID, $sectionID);
            if (is_file($categoryImage)) unlink($categoryImage);
        }
    }
}

function unzip($file) {
    global $rootPath;
    $unziped = array();
    $zip = zip_open($file);
    $path = $rootPath . "admin/uploads/unzip/";
    if (!is_dir($path)) mkdir($path);
    if (is_resource($zip)) {
        $DIRECTORY_SEPARATOR = "/";
        while (($zip_entry = zip_read($zip)) !== false) {
            if (strpos(zip_entry_name($zip_entry), $DIRECTORY_SEPARATOR) !== false) {
                $last = strrpos(zip_entry_name($zip_entry), $DIRECTORY_SEPARATOR);
                $dir = substr(zip_entry_name($zip_entry), 0, $last);
                $file = substr(zip_entry_name($zip_entry), strrpos(zip_entry_name($zip_entry), $DIRECTORY_SEPARATOR) + 1);
                if (!is_dir($path . $dir)) {
                    if (!@mkdir($path . $dir, 0777, true)) return false;
                }
                if (strlen(trim($file)) > 0) {
                    $return = @file_put_contents($path . zip_entry_name($zip_entry), zip_entry_read($zip_entry, zip_entry_filesize($zip_entry))) or die("Unable to uncompress contents of zip file (relative paths mode)");
                    if ($return === false) return false;
                    $unziped[] = zip_entry_name($zip_entry);
                }
            } else {
                file_put_contents($path . zip_entry_name($zip_entry), zip_entry_read($zip_entry, zip_entry_filesize($zip_entry))) or die("Unable to uncompress contents of zip file (root path mode)");
                $unziped[] = zip_entry_name($zip_entry);
            }
        }
    }
    return (count($unziped)) ? $unziped : false;
}

function isMultiCategory() {
    global $system;
    global $sectionID;
    global $db;
    $fieldID = $system->getFieldID("catID", $sectionID);
    $catType = $db->getRecord("select `fieldType` from fields where id='$fieldID'")->fieldType;
    return ($catType == "selectList");

}

function getCategoryData($property = 'src', $article) {
    $index = 0;
    foreach ($_POST['mapping'] as $field) {
        $index++;
        $value = $article[$index - 1];
        if (empty($field)) continue; // ignore inactive fields
        if ($field == "images") {
            $data = "";
            $items = json_decode($value);
            foreach ($items as $item) {
                if ($item->type == "category_image") {
                    $data = $item->$property;
                }
            }
            return $data;
        }
    }
    return false; // No category images for this entry
}

function getCategoryID($category_name) {
    global $db;
    global $variables;
    $category_name = $variables->odyssey_real_escape_string($category_name);
    $q = "select `catID` from `content_articles_categories` where `title`='$category_name'";
    return $db->getRecord($q)->catID;
}

function getArticleID($article_name) {
    global $db;
    global $variables;
    $article_name = $variables->odyssey_real_escape_string($article_name);
    // try if it's article
    $q = "select `mainID` from `content_articles` where `title`='$article_name'";
    $articleID = $db->getRecord($q)->mainID;
    if($articleID){
        return $articleID;
    }else{ // try if it's page
        $q = "select `mainID` from `content_pages` where `title`='$article_name'";
        $articleID = $db->getRecord($q)->mainID;
        return $articleID; // found pageID or return false!
    }
}

function getMediabankName($img_id, $images) {
    foreach ($images as $image) {
        if ($image->img_id == $img_id) return basename($image->src);
    }
    return false; // no results
}

function getMediabankID($media_src) {
    global $db, $imported_text;
    $title = $imported_text . $media_src;
    $q = "select `id` from `mediabank` where `title`='$title'";
    return $db->getRecord($q)->id;
}

function getInternalImagePath() {
    global $imageSize;
    $mediabankPath = ($imageSize == "medium") ? "../mediabank/medium/medium_" : "../mediabank/images/";
    return $mediabankPath;
}

function getArticleImages($article) {
    $index = 0;
    foreach ($_POST['mapping'] as $field) {
        $index++;
        $value = $article[$index - 1];
        if (empty($field)) continue; // ignore inactive fields
        if ($field == "images") {
            $images = array();
            $items = json_decode($value);
            foreach ($items as $item) {
                if ($item->type && $item->type != "category_image") {
                    $images[] = $item;
                }
            }
            return $images;
        }
    }
    return false; // No category images for this entry
}

function restoreBodyData($data) {
    global $system, $fileSystem, $db, $system, $variables, $language, $langID;
    reset_loading();
    $loading_counter = 0;
    $data_count = count($data);
    $importLangID = $langID;
    foreach ($data as $item) {
        $mediaAttached = array();
        $articleID = $item->id;
        $articleBody = $item->body;
        $articleImages = $item->images;
        $section = $item->section;
        $sectionID = $system->getTableSectionID($section);
        $dom = new DOMDocument();
        $dom->encoding = 'UTF-8';
        libxml_use_internal_errors(true);
        // load HTML with hack
        $dom->loadHTML('<?xml encoding="UTF-8">' . $articleBody);
        foreach ($dom->childNodes as $item) {
            if ($item->nodeType == XML_PI_NODE) {
                $dom->removeChild($item);// remove hack
            }
        }
        $tags = $dom->getElementsByTagName('a');
        $length = $tags->length;
        for ($i = 0; $i < $length; $i++) {
            $node = $tags->item($i);
            if($node) {
                $node->removeAttribute('class');
                $node->removeAttribute('id');
                $href = $node->getAttribute('href');
                if (preg_match('/(http|https):\/\/odyssey\.cms\?category\=/', $href)) { // an odyssey link to specific category must be set
                    parse_str($href, $href_data);
                    $category_name = urldecode($href_data[array_keys($href_data)[0]]); // it's base64 encoded
                    $catID = getCategoryID($category_name);
                    $link = ($catID) ? "index.php?section=articles&view=list&catID=" . $catID : "javascript:void(0)";
                    $node->setAttribute("href", $link);
                    continue;
                }
                if (preg_match('/(http|https):\/\/odyssey\.cms\?article\=/', $href)) { // an odyssey link to specific article must be set
                    parse_str($href, $href_data);
                    $article_name = urldecode($href_data[array_keys($href_data)[0]]); // it's base64 encoded
                    $id = getArticleID($article_name);
                    $link = ($id) ? "index.php?section=articles&view=node&id=" . $id : "javascript:void(0)";
                    $node->setAttribute("href", $link);
                    continue;
                }
                if (preg_match('/(http|https):\/\/odyssey\.cms\?page\=/', $href)) { // an odyssey link to specific page must be set
                    parse_str($href, $href_data);
                    $article_name = urldecode($href_data[array_keys($href_data)[0]]); // it's base64 encoded
                    $id = getArticleID($article_name);
                    $link = ($id) ? "index.php?section=pages&view=node&id=" . $id : "javascript:void(0)";
                    $node->setAttribute("href", $link);
                    continue;
                }
                $node->setAttribute("target", "_blank"); // ok its not internal article/page/category link, so open it in new window
                if (preg_match('/(http|https):\/\/odyssey\.cms\?file\=/', $href)) { // an odyssey link to specific mediabank file must be set
                    parse_str($href, $href_data);
                    $file_id = $href_data[array_keys($href_data)[0]];
                    $file_name = getMediabankName($file_id, $articleImages);
                    $extension = $fileSystem->getExtensionByFileName($file_name);
                    if ($fileSystem->isValidExtension($extension)) {
                        $bankID = getMediabankID($file_name);
                        if ($bankID && !in_array($file_name, $mediaAttached['article_' . $articleID])) {
                            $url = "mediabank/" . $bankID . "." . $extension;
                            $node->setAttribute("href", $url);
                            // attach file
                            $fileTitle = $node->textContent;
                            $db->query("INSERT INTO `files` VALUES('','$bankID', '$sectionID', '$articleID', '0')");
                            $fileID = $db->lastID();
                            if ($fileID) {
                                $Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
                                $LRecords = $db->getRows($Lresult);
                                foreach ($LRecords as $Lrow) {
                                    $languageID = $Lrow->id;
                                    $title = ($languageID != $importLangID) ? $fileTitle . " (" . str_replace("_", "", $language->getLanguageExtension($languageID)) . ")" : $fileTitle;
                                    $languageID = $Lrow->id;
                                    $title = $variables->odyssey_real_escape_string($variables->filterQuotes($title));
                                    $keys = "id,fileID,langID,title";
                                    $values = "'','$fileID','$languageID','$title'";
                                    if ($title) {
                                        $query = "INSERT INTO content_files (" . $keys . ") VALUES(" . $values . ")";
                                        $db->query($query);
                                    }
                                }
                                $mediaAttached['article_' . $articleID][] = $file_name;
                            } else {
                                $db->query("delete from `files` where `id`='$fileID'"); // something went wrong, cancel the record
                            }
                        }
                    }
                    if ($node->getAttribute('data-type') == "playlist") {
                        $node->parentNode->removeChild($node); // remove tag
                        $i--; // fix loop index after tag removal
                    }
                    continue;
                }
                if (preg_match('/(http|https):\/\/odyssey\.cms\?video\=/', $href)) { // a video attachment must be set
                    parse_str($href, $href_data);
                    $video_id = $href_data[array_keys($href_data)[0]];
                    list($provider, $videoCode) = explode("videocode", $video_id);
                    if ($videoCode && $provider && !in_array($video_id, $mediaAttached['article_' . $articleID])) {
                        // attach video
                        $videoTitle = $node->textContent;
                        $alias = $variables->toLatin($videoTitle);
                        $db->query("INSERT INTO `videos` VALUES('','1','0','$alias','0','$videoCode','$articleID', '$sectionID', '$provider')");
                        $mainID = $db->lastID();
                        if ($mainID) {
                            $Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
                            $LRecords = $db->getRows($Lresult);
                            foreach ($LRecords as $Lrow) {
                                $languageID = $Lrow->id;
                                $title = ($languageID != $importLangID) ? $videoTitle . " (" . str_replace("_", "", $language->getLanguageExtension($languageID)) . ")" : $videoTitle;
                                $languageID = $Lrow->id;
                                $title = $variables->odyssey_real_escape_string($variables->filterQuotes($title));
                                $keys = "id,mainID,langID,title";
                                $values = "'','$mainID','$languageID','$title'";
                                if ($title) {
                                    $query = "INSERT INTO content_videos (" . $keys . ") VALUES(" . $values . ")";
                                    $db->query($query);
                                }
                            }
                            $mediaAttached['article_' . $articleID][] = $video_id;
                        } else {
                            $db->query("delete from `videos` where `id`='$mainID'"); // something went wrong, cancel the record
                        }
                    }
                    $node->parentNode->removeChild($node); // remove tag
                    $i--; // fix loop index after tag removal
                    continue;
                }
            }
        } // a tags
        $tags = $dom->getElementsByTagName('img');
        $length = $tags->length;
        for ($i = 0; $i < $length; $i++) {
            $node = $tags->item($i);
            if($node) {
                $node->removeAttribute('width');
                $node->removeAttribute('height');
                $node->removeAttribute('class');
                $node->removeAttribute('id');
                $src = $node->getAttribute('src');
                if (preg_match('/(http|https):\/\/odyssey\.cms\?image\=/', $src)) { // an odyssey link to specific mediabank image must be set
                    parse_str($src, $src_data);
                    $img_id = $src_data[array_keys($src_data)[0]];
                    $img_src = getMediabankName($img_id, $articleImages);
                    $bankID = getMediabankID($img_src);
                    if ($bankID) {
                        $extension = $fileSystem->getExtensionByFileName($img_src);
                        $img_src = getInternalImagePath() . $bankID . "." . $extension;
                        $node->setAttribute("src", $img_src);
                    }
                    if ($node->getAttribute('data-type') == "gallery") {
                        $parent = $node->parentNode;
                        $node->parentNode->removeChild($node); // remove tag
                        $parent->parentNode->removeChild($parent); // remove parent tag
                        $i--; // fix loop index after tag removal
                    }
                } // if valid img src
            }
        } // img tags
        $articleBody = str_replace(array(
            '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">',
            '<html><body>',
            '</body></html>'
        ), "", $dom->saveHTML());
        $Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
        $articleBody = html_entity_decode($articleBody);
        $articleBody = preg_replace('/(<br ?\/?>)+/', '<br>' , $articleBody); // remove multiple <br> tags
        $articleBody = $variables->odyssey_real_escape_string($articleBody);
        foreach ($Lresult as $Lrow) {
            $languageID = $Lrow->id;
            $table = "content_" . $section;
            $q = "UPDATE `$table` SET `body`='$articleBody' where `mainID`='$articleID' and `langID`='$languageID'";
            $db->query($q);
        }
        $loading_counter++;
        manage_loading('Importing data', $data_count, $loading_counter);
    } // foreach
}


