<?php
require("dll.php");
set_time_limit(0); // no time out for this script
ini_set("memory_limit", "320M");
$parameters->importParameters();
$sefAdmin = new sef(); // override the $sef parameter from the last command
$_SESSION['iconType'] = "icons";
unset($_SESSION['sef']); // reset sef urls cache (it will be recreated by the sef class at first call)
$import_url = $variables->makeURL($domain_name) . '/' . $_SESSION['mp'] . 'import.php';
$loading_url = $variables->makeURL($domain_name) . '/' . $_SESSION['mp'] . 'loading.php';
?>

<!doctype html>
<html class="module_import_articles">
<head>
    <meta charset="utf-8">
    <title>Import Articles from other CMS</title>
    <link rel="stylesheet" type="text/css" href="<?php echo "//" . $domain_name . "/admin/css/admin.css"; ?>">
    <link rel="stylesheet" type="text/css" href="css/import.css">
    <script type="text/javascript" src="js/jquery-3.2.1.min.js"></script>
    <script type="text/javascript" src="<?php echo "//" . $domain_name . "/admin/js/admin.js"; ?>"></script>
    <script type="text/javascript" src="js/import.js"></script>
    <script type="text/javascript" src="js/progressbar.js"></script>
    <script type="text/javascript">
        var session = '<?php echo $session;?>';
        var import_url = '<?php echo $import_url;?>';
        var loading_url = '<?php echo $loading_url;?>';
        <?php
        if($_POST['sse'] == '1'){ // import content
        ?>
        sse(); // start server sent events on import
        console.log('Server Sent Events started...')
        <?php
        }
        ?>
    </script>
</head>

<body class="module_import_articles silver_body">
<div id="loading">
    <noscript>
        <br>
        <br>
        <p align="center">
            <img src="images/warning_big.png" alt="warning" width="35" height="40"></p>
        <p style="color: #CC0000"><?php echo t('Πρέπει να ενεργοποιήσετε την Javascript για να λειτουργήσει σωστά αυτή η σελίδα'); ?>!</p>
    </noscript>
</div>
<div id="step3">
    <div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΑΡΘΡΩΝ ΑΠΟ CMS"); ?></div>
    <div class="import_step_container">
        <div class="import_step"><?php echo t("Βήμα"); ?>
            <div class="import_step_number">3</div>
        </div>
        <div class="arrow-right"></div>
        <div class="import_step_description">
            <?php
            echo t("Η διαδικασία της εισαγωγής ξεκίνησε") . ". ";
            echo t("Μην κλείσετε αυτό το παράθυρο μέχρι να ολοκληρωθεί η διαδικασία") . "! ";
            ?>
        </div>
    </div>
</div>
<div id="live_loading"></div>
<div id="static_loading"><?php echo t("Διαδικασία εισαγωγής περιεχομένου σε εξέλιξη..."); ?></div>
<div id="app_container">
    <?php
    $messages->printSystemMessages();
    if ($_REQUEST['submitedData']) {
        if ($import_type == "upload") {
            $zip = $_FILES['zipFile']['tmp_name'];
            if ($zip) {
                copy($_FILES['zipFile']['tmp_name'], $zip_filename);
            } elseif ($step == "2") {
                $import_type = "server"; // try if it's  already uploaded fromm previous step
            }
        }
        if ($import_type == "server") {
            $zip = (is_file($zip_filename)) ? $zip_filename : false; // try to locate uploaded file via ftp
        }
        if ($zip) {
            // proceed to extract zip file
            $unziped = unzip($zip, true); // true stands for admin version of unzip method
            ?>
            <a href="javascript:closeImportArticles()" class="closeImportArticles" title="<?php echo t("Κλείσιμο"); ?>"></a>
            <div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΑΡΘΡΩΝ ΑΠΟ CMS"); ?></div>
            <?php
            if ($unziped) {
                $mapping = is_array($_POST['mapping']);
                $foundCSV = false;
                $articles = array();
                $path = $rootPath . "admin/uploads/unzip/";
                foreach ($unziped as $unzipedFile) {
                    if ($unzipedFile == "articles.csv") {
                        $foundCSV = true;
                        $csvFile = $path . $unzipedFile;
                        if (($handle = fopen($csvFile, "r")) !== FALSE) {
                            $headers = fgetcsv($handle, 0, $delimiter, $enclosure); //read the first line and get headers as array in $data
                            $row = 0;
                            while (($data = fgetcsv($handle, 0, $delimiter, $enclosure)) !== FALSE) {
                                $row++;
                                $articles[] = $data;
                            }
                            fclose($handle);
                        }
                        if (!$mapping) { // start mapping fields
                            $articleFields = $db->getRecords("select fieldVarName, fieldDescription from `fields` where active=1 and tableSectionID='$sectionID' order by sort");
                            $skipFields = array(t("Υπότιτλος"), t("Ανήκει στον χρήστη"), t("Ημερομηνία του event"));
                            ?>
                            <article>
                                <?php $messages->printSystemMessages(); ?>
                                <div class="import_step_container">
                                    <div class="import_step"><?php echo t("Βήμα"); ?>
                                        <div class="import_step_number">2</div>
                                    </div>
                                    <div class="arrow-right"></div>
                                    <div class="import_step_description">
                                        <?php
                                        echo t("Αντιστοιχήστε κάθε πεδίο του csv αρχείου με τα πεδία του πίνακα της ΒΔ των άρθρων του Odyssey") . ". ";
                                        echo t("Όσα πεδία του csv αρχείου δεν θέλετε να χρησιμοποιηθούν, αντιστοιχήστε τα με την επιλογή [Ανενεργό πεδίο]") . ". ";
                                        ?>
                                    </div>
                                </div>
                                <form id="mappingForm" action="" method="post" class="admin_form form_centerd visible">
                                    <?php
                                    $counter = 0;
                                    foreach ($headers as $header) {
                                        $counter++;
                                        ?>

                                        <div class="mapping_pairs">
                                            <div class="admin_form_element" style="clear: none !important; float:left">
                                                <div class="admin_label">
                                                    <p><?php echo t("Το csv πεδίο"); ?> : </p>
                                                </div>
                                                <div class="csv_header">
                                                    <?php
                                                    echo $header;
                                                    ?>
                                                </div>
                                            </div>
                                            <div class="admin_form_element" style="clear: none !important;float:right">
                                                <div class="admin_label">
                                                    <p><?php echo t("Αντιστοιχεί στο πεδίο"); ?> : </p>
                                                </div>
                                                <div>
                                                    <select name="mapping[csv_<?php echo $counter; ?>]" class="listbox" style="min-width: 150px">
                                                        <option value=""> -- <?php echo t("Ανενεργό πεδίο"); ?> --</option>
                                                        <?php
                                                        foreach ($articleFields as $articleField) {
                                                            if (in_array(t($articleField->fieldDescription), $skipFields)) continue; // skip Odyssey specific fields
                                                            ?>
                                                            <option value="<?php echo $articleField->fieldVarName; ?>"<?php if ($header == t($articleField->fieldDescription)) echo " selected"; ?>>
                                                                <?php echo t($articleField->fieldDescription); ?>
                                                            </option>
                                                            <?php
                                                        }
                                                        ?>
                                                        <option value="active"<?php if ($header == t("Δημοσιευμένο")) echo " selected"; ?>><?php echo t("Δημοσιευμένο"); ?></option>
                                                        <option value="private"<?php if ($header == t("Επίπεδο πρόσβασης")) echo " selected"; ?>><?php echo t("Επίπεδο πρόσβασης"); ?></option>
                                                        <option value="images"<?php if ($header == t("Εικόνες")) echo " selected"; ?>><?php echo t("Εικόνες"); ?></option>
                                                    </select>
                                                </div>
                                            </div>

                                        </div>
                                        <?php
                                    }
                                    ?>
                                    <div class="admin_form_element" style="padding: 30px 0">
                                        <div class="admin_checkbox_wrapper">
                                            <input name="allowJavascript" id="allowJavascript" value="1" type="checkbox" checked="checked">
                                            <p>
                                                <?php echo t("Να διατηρηθεί ο κώδικας της Javascript στα HTML περιεχόμενα"); ?><br>
                                                <span id="allowJavascriptWrapper">
                                                    <img src="images/warning_icon.png" style="float:left; margin: 10px 10px 0 0;">
                                                    <span style="color: red"><?php echo t("πρέπει να είστε σίγουροι για το<br>περιεχόμενο γιατί υπάρχει<br>κίνδυνος για XSS attack"); ?></span>
                                                </span>
                                            </p>
                                        </div>
                                    </div>
                                    <div class="admin_form_element">
                                        <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Εισαγωγή"); ?>">
                                        <input name="step" type="hidden" value="2">
                                        <input name="import_type" type="hidden" value="<?php echo $import_type; ?>">
                                    </div>
                                </form>
                            </article>
                            <?php
                        }
                    }
                }
                if (!$foundCSV) {
                    $messages->addError(t("Δεν βρέθηκε το αρχείο εισαγωγής άρθρων [ articles.csv ]"));
                } else {
                    if ($mapping) {
                        // starting import process
                        $purifierError = false;
                        if (!$allowJavascript) {
                            $filterFile = "filter/HTMLPurifier.auto.php";
                            $filterConfig = "filter/purifier_config.php";
                            if (is_file($filterFile) && is_file($filterConfig)) {
                                require_once($filterFile);
                                require_once($filterConfig);
                                global $purifier;
                                $purifier = new HTMLPurifier($config);
                            } else {
                                $purifierError = true;
                                $messages->addError("HTMLPurify plugin is missing while Javascript is set to be disallowed.");
                                $messages->addError("Import process terminated for security reasons.");
                            }
                        }
                        if (!$messages->hasErrors) {
                            $mediaImported = $mediaAttached = $bankIDs = array();
                            $data = array(); // array to store data for restoreBodyData()
                            $vars = $Lvars = $pages_vars = $pages_Lvars = array();
                            $_vars = $variables->getVarNamesByLanguage($sectionID, 0); // get non multilingual var names for articles
                            $_Lvars = $variables->getVarNamesByLanguage($sectionID, 1); // get multilingual var names for articles
                            foreach ($_vars as $key => $var) $vars[$key] = "`" . $var . "`";
                            foreach ($_Lvars as $key => $var) $Lvars[$key] = "`" . $var . "`";
                            $_pages_vars = $variables->getVarNamesByLanguage($pages_sectionID, 0); // get non multilingual var names for pages
                            $_pages_Lvars = $variables->getVarNamesByLanguage($pages_sectionID, 1); // get multilingual var names for pages
                            foreach ($_pages_vars as $key => $var) $pages_vars[$key] = "`" . $var . "`";
                            foreach ($_pages_Lvars as $key => $var) $pages_Lvars[$key] = "`" . $var . "`";
                            $system_vars = array("`active`", "`private`", "`sort`", "`alias`");
                            $Lsystem_vars = array("`mainID`", "`langID`");

                            $keys = array_merge($system_vars, $vars);
                            $Lkeys = array_merge($Lsystem_vars, $Lvars);
                            $single_keys = implode(",", $keys);
                            $Lkeys = implode(",", $Lkeys);

                            $pages_keys = array_merge($system_vars, $pages_vars);
                            $pages_Lkeys = array_merge($Lsystem_vars, $pages_Lvars);
                            $pages_single_keys = implode(",", $pages_keys);
                            $pages_Lkeys = implode(",", $pages_Lkeys);

                            if ($removeExisting) removeContent('articles'); // any related to articles content will be removed before the import process
                            $loading_counter = 0;
                            $articles_count = count($articles);
                            $preserveLangID = $langID;
                            foreach ($articles as $article) {
                                $counter = 0;
                                $foundTitle = false;
                                foreach ($_POST['mapping'] as $field) {
                                    $counter++;
                                    $value = $article[$counter - 1];
                                    $article_data = (object)array(); // object to store $articleBody and $images
                                    if (empty($field)) continue; // ignore inactive fields
                                    if ($field == "title") {
                                        $foundTitle = true;
                                        $articleTitle = $variables->odyssey_real_escape_string($value);
                                        $articleTitle = $content->remove_html_comments($articleTitle);
                                    } elseif ($field == "minitext") {
                                        $articleMinitext = ($purifier) ? $purifier->purify($value) : $value;
                                        $articleMinitext = $variables->odyssey_real_escape_string($value);
                                        $articleMinitext = $content->remove_html_comments($articleMinitext);
                                        $articleMinitext = $variables->getMinitext($articleMinitext, $maxChars);
                                    } elseif ($field == "body") {
                                        $articleBody = ($purifier) ? $purifier->purify($value) : $value;
                                        $articleBody = $variables->odyssey_real_escape_string($value);
                                        $articleBody = $content->remove_html_comments($articleBody);
                                    } elseif ($field == "catID") {
                                        $categoryTitle = $variables->odyssey_real_escape_string($value);
                                        if (trim($categoryTitle) != "__PAGE__") {
                                            $categoryImage = basename(getCategoryData('src', $article));
                                            $categoryDescription = getCategoryData('description', $article);
                                            $q = "select ac.id from $category_section as ac, content_$category_section as cac 
                                                where ac.id=cac.catID 
                                                and ac.parent='0' 
                                                and cac.title='$categoryTitle' 
                                                and cac.langID='$importLangID'";
                                            $catRecord = $db->getRecord($q);
                                            $catID = $catRecord->id;
                                            if (!$catID && !empty($categoryTitle)) {
                                                // --------------------------------------------------------------------------------------------------------------------------------------------------
                                                // create the category
                                                // --------------------------------------------------------------------------------------------------------------------------------------------------
                                                $q = "select MAX(sort) as sort from " . $category_section;
                                                $row = $db->getRecord($q);
                                                $sort = $row->sort;
                                                $sort++;
                                                $alias = $variables->toLatin($categoryTitle);
                                                $basicAlias = $alias;
                                                if ($categories->isPreorderTreeTraversal($category_section)) {
                                                    $q = "select R from $category_section where id='0'";
                                                    $limits = $db->getRecord($q);
                                                    $R = $limits->R;
                                                    $leftValue = $R + 1;
                                                    $rightValue = $R + 2;
                                                    $db->query("UPDATE $category_section SET R=R+2 WHERE R>$R");
                                                    $db->query("UPDATE $category_section SET L=L+2 WHERE L>$R");
                                                    $q = "INSERT INTO " . $category_section . " VALUES('','0','_self','$sort','0','$alias','0','0','0','0','', '$leftValue', '$rightValue')";
                                                } else {
                                                    $q = "INSERT INTO " . $category_section . " VALUES('','0','_self','$sort','0','$alias','0','0','0','0','')";
                                                }
                                                $db->query($q);
                                                $catID = $db->lastID();
                                                // add the alias
                                                $aliasIndex = NULL;
                                                $aliases = $sefAdmin->isAliasExists($basicAlias, $catID, $sectionID);
                                                while ($aliases) {
                                                    $aliasIndex = (int)$aliasIndex;
                                                    $aliasIndex++;
                                                    $aliasToTest = $basicAlias . "_" . $aliasIndex;
                                                    $aliases = $sefAdmin->isAliasExists($aliasToTest, $catID, $sectionID);
                                                }
                                                $basicAlias = ($aliasToTest) ? $aliasToTest : $basicAlias;
                                                $keys = "`id`, `active`, `private`, `alias`, `sectionID`, `itemID`, `isCategory`";
                                                $values = "'', '1', '1', '" . $basicAlias . "', '" . $sectionID . "', '" . $catID . "', '1'";
                                                $q = "INSERT INTO aliases (" . $keys . ") VALUES(" . $values . ")";
                                                $db->query($q);
                                                $aliasID = $db->lastID();
                                                $content_table = "content_" . $category_section;
                                                $Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
                                                foreach ($Lresult as $Lrow) {
                                                    $keys = "id, catID, langID, title, minitext, link";
                                                    $alias = $variables->toLatin($categoryTitle);
                                                    list($part1, $part2) = explode("_", $basicAlias);
                                                    if ($part2) $alias = $alias . "_" . $part2;
                                                    $languageID = $Lrow->id;
                                                    $values = "'','" . $catID . "','" . $languageID . "','" . $categoryTitle . "','',''";
                                                    $q = "INSERT INTO content_" . $category_section . " (" . $keys . ") VALUES(" . $values . ")";
                                                    $db->query($q);
                                                    // add the multilingual alias
                                                    $keys = "`id`, `mainID`, `langID`, `title`";
                                                    $values = "'', '" . $aliasID . "', '" . $languageID . "', '" . $alias . "'";
                                                    $q = "INSERT INTO content_aliases (" . $keys . ") VALUES(" . $values . ")";
                                                    $db->query($q);
                                                }

                                                // upload category image
                                                if ($categoryImage) {
                                                    $ext = $fileSystem->getExtensionByFileName($categoryImage);
                                                    $filetypeID = $fileSystem->isValidExtension($ext);
                                                    if ($filetypeID) {
                                                        if ($fileSystem->isImageExtension($ext)) {
                                                            $newFileName = $rootPath . "mediabank/cat" . $sectionID . "_" . $catID . "." . $ext;
                                                            if (copy($path . $categoryImage, $newFileName)) {
                                                                // set dimensions according to saved parameters
                                                                $imgDim = GetImageSize($newFileName);
                                                                $originalWidth = $imgDim[0];
                                                                $originalHeight = $imgDim[1];
                                                                $cat_icon_width = $parameters->getParameter("cat_icon_width");
                                                                $cat_icon_height = $parameters->getParameter("cat_icon_height");
                                                                if (($originalWidth > $cat_icon_width) || ($originalHeight > $cat_icon_height)) { // don't resize if both sides are smaller
                                                                    if (($originalWidth < $cat_icon_width)) $cat_icon_width = $originalWidth;
                                                                    if (($originalHeight < $cat_icon_height)) $cat_icon_height = $originalHeight;
                                                                    if ($ext == "png") {
                                                                        $src_img = imagecreatefrompng($newFileName);
                                                                        $dst_img = imagecreatetruecolor($cat_icon_width, $cat_icon_height);
                                                                        imagecolortransparent($dst_img, imagecolorallocate($dst_img, 0, 0, 0));
                                                                        imagealphablending($dst_img, false);
                                                                        imagesavealpha($dst_img, true);
                                                                        imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $cat_icon_width, $cat_icon_height, $originalWidth, $originalHeight);
                                                                        imagepng($dst_img, $newFileName);
                                                                        imagedestroy($src_img);
                                                                        imagedestroy($dst_img);
                                                                    }
                                                                    if ($ext == "gif") {
                                                                        $src_img = imagecreatefromgif($newFileName);
                                                                        $dst_img = imagecreate($cat_icon_width, $cat_icon_height);
                                                                        imagecolortransparent($dst_img, imagecolorallocate($dst_img, 0, 0, 0));
                                                                        imagealphablending($dst_img, false);
                                                                        imagesavealpha($dst_img, true);
                                                                        imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $cat_icon_width, $cat_icon_height, $originalWidth, $originalHeight);
                                                                        imagegif($dst_img, $newFileName);
                                                                        imagedestroy($src_img);
                                                                        imagedestroy($dst_img);
                                                                    }
                                                                    if ($ext == "jpg" || $ext == "jpeg") {
                                                                        $src_img = imagecreatefromjpeg($newFileName);
                                                                        $dst_img = imagecreatetruecolor($cat_icon_width, $cat_icon_height);
                                                                        imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $cat_icon_width, $cat_icon_height, $originalWidth, $originalHeight);
                                                                        imagejpeg($dst_img, $newFileName, 70);
                                                                        imagedestroy($src_img);
                                                                        imagedestroy($dst_img);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                // --------------------------------------------------------------------------------------------------------------------------------------------------
                                                // end of the category creation
                                                // --------------------------------------------------------------------------------------------------------------------------------------------------
                                            }
                                        }
                                    } elseif ($field == "published") {
                                        if ($dates->isDate($value)) {
                                            $published = ($dates->isDate($value)) ? (int)$value : time(); // set today if no valid date provided
                                        }
                                    } elseif ($field == "active" || $field == "featured" || $field == "private") {
                                        ${$field} = empty($value) ? 0 : 1;
                                    } elseif ($field == "images") {
                                        $images = getArticleImages($article);
                                    }
                                }

                                // start importing the article
                                if (empty($foundTitle) || empty($articleTitle)) continue; // ignore articles without title
                                if (empty($categoryTitle)) continue; // ignore uncategorised articles
                                $section_name = (trim($categoryTitle) == "__PAGE__") ? "pages" : "articles";
                                $sectionID = $system->getTableSectionID($section_name);
                                $final_vars = ($section_name == "pages") ? $_pages_vars : $_vars;
                                $final_Lvars = ($section_name == "pages") ? $_pages_Lvars : $_Lvars;
                                $final_single_keys = ($section_name == "pages") ? $pages_single_keys : $single_keys;
                                $final_Lkeys = ($section_name == "pages") ? $pages_Lkeys : $Lkeys;
                                $q = "select a.id from `$section_name` as a, `content_$section_name` as ca  
                                                where a.id=ca.mainID 
                                                and ca.title='$articleTitle' 
                                                and ca.langID='$importLangID'";
                                $articleRecord = $db->getRecord($q);
                                $articleExists = $articleRecord->id;
                                if (!$articleExists && !empty($articleBody)) {
                                    // proceed to create the article
                                    $article_data->body = stripslashes(str_replace(array('\\r\\n', '\\r', '\\n'), '', $articleBody));
                                    $article_data->section = $section_name;
                                    $alias = $variables->toLatin($articleTitle);
                                    $basicAlias = $alias;
                                    $userID = 1; // assign article to system user
                                    $systemValues = array("'$active'", "'$private'", "'0'", "'$alias'");
                                    $values = $Lvalues = array();
                                    foreach ($final_vars as $key => $var) $values[$key] = "'" . ${$var} . "'";
                                    $values = array_merge($systemValues, $values);
                                    $values = implode(",", $values);
                                    $q = "INSERT INTO `$section_name` (" . $final_single_keys . ") VALUES(" . $values . ")";
                                    if ($db->query($q)) { // successful article insertion
                                        $articleID = $db->lastID();
                                        $article_data->id = $articleID;
                                        // add the article alias
                                        $aliasIndex = 0;
                                        $aliasToTest = "";
                                        $aliases = $sefAdmin->isAliasExists($basicAlias, $articleID, $sectionID);
                                        while ($aliases) {
                                            $aliasIndex++;
                                            $aliasToTest = $basicAlias . "_" . $aliasIndex;
                                            $aliases = $sefAdmin->isAliasExists($aliasToTest, $articleID, $sectionID);
                                        }
                                        $basicAlias = ($aliasToTest) ? $aliasToTest : $basicAlias;
                                        $keys = "`active`, `private`, `alias`, `sectionID`, `itemID`, `isCategory`";
                                        $values = "'1', '1', '" . $basicAlias . "', '" . $sectionID . "', '" . $articleID . "', '0'";
                                        $q = "INSERT INTO aliases (" . $keys . ") VALUES(" . $values . ")";
                                        $db->query($q);
                                        $aliasID = $db->lastID();
                                        $Lresult = $db->getRecords("SELECT * FROM languages WHERE active=1 ");
                                        foreach ($Lresult as $Lrow) {
                                            $languageID = $Lrow->id;
                                            $title = ($languageID != $importLangID) ? $articleTitle . " (" . str_replace("_", "", $language->getLanguageExtension($languageID)) . ")" : $articleTitle;
                                            $alias = $variables->toLatin($title);
                                            list($part1, $part2) = explode("_", $basicAlias);
                                            if ($part2) $alias = $alias . "_" . $part243edxc;
                                            $mainID = $articleID;
                                            $langID = $languageID;
                                            $minitext = $articleMinitext;
                                            $body = $articleBody;
                                            $LsystemValues = array("'$mainID'", "'$langID'");
                                            foreach ($final_Lvars as $key => $var) $Lvalues[$key] = "'" . ${$var} . "'";
                                            $values = array_merge($LsystemValues, $Lvalues);
                                            $values = implode(",", $values);
                                            $q = "INSERT INTO content_$section_name (" . $final_Lkeys . ") VALUES(" . $values . ")";
                                            $db->query($q);
                                            // add the multilingual alias
                                            $keys = "`mainID`, `langID`, `title`";
                                            $values = "'" . $aliasID . "', '" . $languageID . "', '" . $alias . "'";
                                            $q = "INSERT INTO content_aliases (" . $keys . ") VALUES(" . $values . ")";
                                            $db->query($q);
                                        }
                                        if (isMultiCategory()) {
                                            // assign category to this article as multi category section
                                            $fieldID = $system->getFieldID("catID", $sectionID);
                                            $q = "INSERT INTO `selectlists` VALUES ('', '$sectionID', '$fieldID', '$articleID', '$catID')";
                                            $db->query($q); // assign the category
                                        }
                                        if (count($images)) { // we have images to add and attach for this article
                                            $article_data->images = $images;
                                            $default = true;
                                            foreach ($images as $key=>$image) {
                                                $image_type = $image->type;
                                                $filename = basename($image->src);
                                                if (!in_array($filename, $mediaImported)) {
                                                    $file = $path . $filename;
                                                    $ext = $fileSystem->getExtensionByFileName($filename);
                                                    $filetypeID = $fileSystem->isValidExtension($ext);
                                                    if ($filetypeID) {
                                                        $title = $imported_text . $filename;
                                                        $title = $variables->filterQuotes($title);
                                                        $userID = 1; // Odyshop System User
                                                        $db->query("INSERT INTO mediabank VALUES('','$title','','$filetypeID','$userID')");
                                                        $id = $db->lastID();
                                                        $bankIDs[$filename] = $id;
                                                        $path2 = $rootPath . "admin/uploads/";
                                                        $currentFile = $path2 . $id . "." . $ext;
                                                        if ($fileSystem->isImageExtension($ext)) {
                                                            if (copy($file, $currentFile)) {
                                                                $imageResize = new imageResize($id, $ext, $path2);
                                                                $fileSystem->deleteUploadedFiles($id, $path2);
                                                                $bankID = $id;
                                                                $sort = 0;
                                                                $slider = 0;
                                                                $logo = 0;
                                                            }
                                                        } else { // it's a non-image valid file, Just upload it!
                                                            move_uploaded_file($_FILES['file']['tmp_name'], $currentFile);
                                                            $destinationFile = $id . "." . $ext;
                                                            $fileSystem->copyToMediabank($file, $destinationFile);
                                                        }
                                                        $mediaImported[] = $filename;
                                                        $default = false;   // only the first image must be flagged as default image
                                                    } // end if valid file type
                                                } // end media can be imported
                                                $bankID = $bankIDs[$filename];
                                                if ($fileSystem->isImage($bankID) && $image_type != "body_image" && !in_array($filename, $mediaAttached['article_' . $articleID])) { // it's an image for attachment
                                                    $default = $image->default;
                                                    $db->query("INSERT INTO images VALUES('','$bankID','$sectionID','$articleID','$default', '0', '0', '0')");
                                                    $imgID = $db->lastID();
                                                    $Lresult = $db->query("SELECT * FROM languages WHERE active=1 ");
                                                    $LRecords = $db->getRows($Lresult);
                                                    foreach ($LRecords as $Lrow) {
                                                        $languageID = $Lrow->id;
                                                        $title = $fileSystem->getMediabankTitle($bankID);
                                                        $description = "";
                                                        $keys = "id,imgID,langID,title,description";
                                                        $values = "'','$imgID','$languageID','$title','$description'";
                                                        $query = "INSERT INTO content_images (" . $keys . ") VALUES(" . $values . ")";
                                                        $db->query($query);
                                                    }
                                                    $mediaAttached['article_' . $articleID][] = $filename;
                                                }
                                            }  // end images loop
                                        } // end if images
                                    }// end of successful article submission
                                    $data[] = $article_data; // save object for restoreBodyData()
                                }  // end article exists
                                $loading_counter++;
                                manage_loading('Creating files', $articles_count, $loading_counter);
                            } // end of all articles loop
                            $langID = $preserveLangID; // restore $langID
                            restoreBodyData($data); // this will restore images and links to Odyssey CMS format
                        }  // end of no errors
                        if (!$messages->hasErrors && $step == "2" && $mapping) {

                            array_map('unlink', glob($path . "*")); // clean up unzipped files
                            $messages->addMessage(t("Η εισαγωγή των άρθρων ολοκληρώθηκε με επιτυχία"));
                            $messages->printSystemMessages();
                        }
                    }
                }
            } else {
                $messages->addError(t("Παρουσιάστηκε κάποιο σφάλμα κατά την εξαγωγή των δεδομένων του αρχείου"), true);
            }
//            if ($step == "2" && $mapping && !$messages->hasErrors) unlink($zip_filename);
        } else {
            if ($import_type == "upload") {
                $messages->addError(t("Παρακαλούμε επιλέξτε ένα zip αρχείο που να περιέχει τα προς εισαγωγή άρθρα"), true);
            } else {
                $messages->addError(t("Δεν βρέθηκε κάποιο zip αρχείο στον διακομιστή"), true);
                $messages->addError(t("Παρακαλούμε επιλέξτε ένα zip αρχείο που να περιέχει τα προς εισαγωγή άρθρα"), true);
            }
        }
        if ($messages->hasErrors) {
            if (!$purifierError) {
                ?>
                <a href="javascript:closeImportArticles()" class="closeImportArticles" title="<?php echo t("Κλείσιμο"); ?>"></a>
                <div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΑΡΘΡΩΝ ΑΠΟ CMS"); ?></div>
                <?php
            }
            $messages->printSystemMessages();
            ?>
            <a class="btn btn-success centered" href="import.php?session=<?php echo $_REQUEST['session']; ?>" style="margin-top: 50px"><?php echo t("Δοκιμάστε ξανά"); ?></a>
            <?php
            exit;
        }
    } else {
        ?>

        <article>
            <a href="javascript:closeImportArticles()" class="closeImportArticles" title="<?php echo t("Κλείσιμο"); ?>"></a>
            <div class="section_title"><?php echo t("ΕΙΣΑΓΩΓΗ ΑΡΘΡΩΝ ΑΠΟ CMS"); ?></div>
            <?php
            if ($removeExisting) {
                $messages->addError(t("Προσοχή! Είναι ενεργοποιημένη στις ρυθμίσεις του ενθέματος, η επιλογή για αφαίρεση όλων των υπάρχοντων άρθρων πριν τη νέα εισαγωγή!"));
                $messages->addError(t("Η ενέργεια αυτή είναι μη αναστρέψιμη!"));
                $messages->addError(t("Συνιστάται η λήψη backup των περιεχομένων σας πριν εισάγετε νέα άρθρα"));
            }
            $messages->printSystemMessages();
            ?>
            <div class="import_step_container">
                <div class="import_step"><?php echo t("Βήμα"); ?>
                    <div class="import_step_number">1</div>
                </div>
                <div class="arrow-right"></div>
                <?php
                echo t("Απαιτείται ένα zip αρχείο που περιέχει το csv αρχείο των άρθρων, με τις αντίστοιχες εικόνες άρθρων και κατηγοριών αν υπάρχουν") . ". ";
                echo t("Το συγκεκριμένο csv αρχείο θα πρέπει στην πρώτη γραμμή να περιέχει τις επικεφαλίδες που περιγράφουν τα πεδία") . ". ";
                ?>
            </div>
            <form id="importArticles" action="" method="post" class="admin_form form_centerd visible" enctype="multipart/form-data">
                <fieldset id="import_type_selector">
                    <legend><?php echo t("Επιλέξτε τρόπο εισαγωγής"); ?></legend>
                    <div class="admin_form_element">
                        <div class="admin_checkbox_wrapper">
                            <input class="import_type" id="import_type_full" name="import_type" value="upload" checked="true" type="radio">
                            <p class="admin_form_label"><?php echo t("Zip αρχείο από τον υπολογιστή μου"); ?></p>
                        </div>
                    </div>
                    <div class="form_element">
                        <div class="admin_checkbox_wrapper">
                            <input class="import_type" id="import_type_text" name="import_type" value="server" type="radio">
                            <p class="admin_form_label">
                                <?php echo t("Zip αρχείο στον διακομιστή"); ?>
                                <br>
                                <span>
                                    <?php echo t("Υπάρχει ήδη zip αρχείο με όνομα import.zip στον διακομιστή (server) στην διαδρομή admin/uploads/"); ?>
                                </span></p>
                        </div>
                    </div>
                </fieldset>
                <div class="admin_form_element" id="upload_zip_field">
                    <div class="admin_label">
                        <p>Zip file : </p>
                    </div>
                    <div>
                        <input name="zipFile" type="file" class="listbox" id="zipFile">
                    </div>
                </div>

                <div class="admin_form_element">
                    <input name="submitedData" type="submit" class="btn btn-success" id="submitedData" value="<?php echo t("Επόμενο βήμα"); ?>">
                    <input name="step" type="hidden" value="1">
                    <input name="sse" type="hidden" value="1">
                </div>
            </form>
            <?php echo t("Τα πεδία που δύναται να περιέχει το csv αρχείο με τις αντίστοιχες προτεινόμενες επικεφαλίδες της πρώτης γραμμής είναι τα ακόλουθα") . ":"; ?>
            <ul class="import_field_descriptions">
                <li>
                    <strong><?php echo t("Τίτλος άρθρου"); ?></strong>
                    <div class="import_field_description">
                        <?php
                        echo t("Το πεδίο αυτό πρέπει να περιέχει τον τίτλο του άρθρου όπως θα εμφανίζεται στο site");
                        ?>
                    </div>
                    <div class="import_required_field"><?php echo t("Απαραίτητο πεδίο! Χωρίς τίτλο το άρθρο θα αγνοηθεί κατά τη διαδικασία της μαζικής εισαγωγής"); ?></div>
                </li>
                <li>
                    <strong><?php echo t("Εισαγωγική περιγραφή του άρθρου"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει την εισαγωγική περιγραφή (intro text) του άρθρου"); ?>
                    </div>
                </li>
                <li>
                    <strong><?php echo t("Περιεχόμενο του άρθρου"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει το περιεχόμενο του άρθρου"); ?>
                    </div>
                </li>
                <li>
                    <strong><?php echo t("Όνομα κατηγορίας"); ?></strong>
                    <div class="import_field_description">
                        <?php
                        echo t("Το πεδίο αυτό πρέπει να περιέχει το όνομα της κατηγορίας στην οποία θα ενταχθεί το άρθρο") . ". ";
                        ?>
                    </div>
                    <div class="import_required_field"><?php echo t("Απαραίτητο πεδίο! Χωρίς όνομα κατηγορίας το άρθρο θα αγνοηθεί κατά τη διαδικασία της μαζικής εισαγωγής"); ?></div>
                </li>
                <li>
                    <strong><?php echo t("Ημερομηνία δημοσίευσης"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει την ημερομηνία δημοσίευσης του άρθρου σε μορφή Unix timestamp"); ?>
                    </div>
                </li>
                <li>
                    <strong><?php echo t("Κατάσταση άρθρου"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει την τιμή της κατάστασης του άρθρου (0=αδημοσίευτο, 1=δημοσιευμένο)"); ?>
                    </div>
                </li>
                <li>
                    <strong><?php echo t("Προτεινόμενο άρθρο"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει την τιμή που χαρακτηρίζει αν ένα άρθρο εντάσσεται στα προτεινόμενα (0=μη προτεινόμενο, 1=προτεινόμενο)"); ?>
                    </div>
                </li>
                <li>
                    <strong><?php echo t("Δικαιώματα πρόσβασης"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει την τιμή που χαρακτηρίζει τα δικαιώματα πρόσβασης στο άρθρο (0=μόνο εξουσιοδοτημένοι χρήστες, 1=όλοι οι χρήστες)"); ?>
                    </div>
                </li>
                <li>
                    <strong><?php echo t("Σχετικές εικόνες"); ?></strong>
                    <div class="import_field_description">
                        <?php echo t("Το πεδίο αυτό πρέπει να περιέχει σε μορφή JSON, όλες τις εικόνες που σχετίζονται με το άρθρο, συμπεριλαμβανομένης αν υπάρχει και της εικόνας της κατηγορίας του"); ?>
                    </div>
                </li>
            </ul>
            <?php echo t("Όσες εικόνες αναφέρονται στο csv αρχείο πρέπει να συμπεριλαμβάνονται με το ίδιο όνομα στο zip αρχείο της μαζικής εισαγωγής άρθρων"); ?>
        </article>
        <?php
    }
    ?>
</div>
</body>
</html>