var bar;

jQuery(function ($) {

    $('#loading').hide();

    $('input[name="import_type"]').on('change', function () {
        var value = $('input[name="import_type"]:checked').val();
        var rule = (value == 'upload') ? 'block' : 'none';
        $('#upload_zip_field').css("display", rule);
    }).trigger('change');

    $('#allowJavascript').on('change', function () {
        var rule_value = ($(this).prop('checked')) ? "block" : "none";
        $('#allowJavascriptWrapper').css('display', rule_value);
    }).trigger('change');

    $('#importArticles').on('submit', function (event) {
        $('#loading').show();
    });

    $('#mappingForm').on('submit', function (event) {
        event.preventDefault();
        var form_data = $(this).serialize();
        $('#app_container').hide();
        $('#step3').show();
        bar.setText('Getting info...');
        if (typeof(EventSource) !== 'undefined') { // if sse supported
            $('#live_loading').show();
        } else { // show static loading message
            $('#static_loading').css('display', 'table');
        }
        jQuery.ajax({
            type: "POST",
            url: import_url,
            data: form_data + '&submitedData=1&session=' + session,
            async: true,
            success: function (response) {
                //console.log(response);
                $('body').html(response);
            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log("jqXHR: " + jqXHR);
                console.log("textStatus: " + textStatus);
                console.log("errorThrown: " + errorThrown);
                alert("An error occurred while connecting to " + import_url);
            }
        });
    });

    bar = new ProgressBar.Line('#live_loading', {
        strokeWidth: 4,
        easing: 'easeInOut',
        duration: 1400,
        color: '#9a2a54',
        trailColor: '#c2c2c2',
        trailWidth: 1,
        svgStyle: {width: '100%', height: '100%'},
        text: {
            style: {
                // Text color.
                // Default: same as stroke color (options.color)
                color: '#9a2a54',
                position: 'absolute',
                right: '0',
                top: '30px',
                padding: 0,
                margin: 0,
                transform: null
            },
            autoStyleContainer: false
        },
        step: function (state, bar) {
            //bar.setText('Importing content: ' + Math.round(bar.value() * 100) + ' %');
        }
    });

});

function sse() { // manage loading indicator with server send events
    if (typeof(EventSource) !== 'undefined') { // only if sse supported
        source = new EventSource('loading.php');
        var data;
        source.onmessage = function (event) {
            data = event.data.split('|');
            percent = data[0];
            //console.log('percent: ' + percent);
            task = data[1];
            if (!task) return false;
            if (percent <= 100) {
                bar.animate(percent / 100);  // Number from 0.0 to 1.0
                if (task) {
                    bar.setText(task + ': ' + Math.round(bar.value() * 100) + ' %');
                } else {
                    bar.setText("Getting info...");
                }
            }
            if (task == "Importing data" && percent > 99) { // all tasks completed, close the connection
                source.close();
            }
        };
    }
}

function closeImportArticles() {
    parent.$.fancybox.close();
}
